MrMap/urls.py
from django.contrib import admin
from django.urls import path, include

from MrMap.settings import DEBUG

urlpatterns = [
    # path('', login, name="login"),
    # path('logout/', logout, name='logout'),
    # path('password-reset/', password_reset, name='password-reset'),
    # path('register/', register, name='register'),
    # path('activate/<activation_hash>', activate_user, name='activate-user'),
    path('admin/', admin.site.urls),
    path('', include('users.urls')),
    path('structure/', include('structure.urls')),
    path('resource/', include('service.urls')),
    path('monitoring/', include('monitoring.urls')),
    path('editor/', include('editor.urls')),
    path('captcha/', include('captcha.urls')),
    path("i18n/", include("django.conf.urls.i18n")),
    path('api/', include('api.urls')),
    path('csw/', include('csw.urls'))
]

if DEBUG:
    import debug_toolbar
    urlpatterns.append(
        path('__debug__/', include(debug_toolbar.urls))
    )

handler404 = "structure.views.handler404"
handler500 = "structure.views.handler500"

api/urls.py
"""
Author: Michel Peltriaux
Organization: Spatial data infrastructure Rhineland-Palatinate, Germany
Contact: michel.peltriaux@vermkv.rlp.de
Created on: 15.08.19

"""

from django.urls import path, include


# Routers provide an easy way of automatically determining the URL conf.
from rest_framework import routers

from api.views import *

router = routers.DefaultRouter()
# catalogue api
router.register('catalogue', CatalogueViewSet, basename="catalogue")
router.register('suggestion', SuggestionViewSet, basename="suggestion")
router.register('category', CategoryViewSet, basename="category")
# modular parts of api
router.register('organization', OrganizationViewSet, basename="organization")
router.register('pending-task', PendingTaskViewSet, basename="pending-task")
router.register('metadata', MetadataViewSet, basename="metadata")
router.register('service', ServiceViewSet, basename="service")
router.register('layer', LayerViewSet, basename="layer")
router.register('group', GroupViewSet, basename="group")
router.register('monitoring', MonitoringViewSet, basename="monitoring")

app_name = "api"
urlpatterns = [
    path("", include(router.urls)),
    path("menu", menu_view, name="menu"),
    path("generate-token", generate_token, name="generate-token"),
]

csw/urls.py
"""
Author: Michel Peltriaux
Organization: Spatial data infrastructure Rhineland-Palatinate, Germany
Contact: michel.peltriaux@vermkv.rlp.de
Created on: 05.05.20

"""
from django.urls import path

from csw.views import *

app_name = 'csw'
urlpatterns = [
    path('', get_csw_results, name='get-csw-results'),
    path('harvest/<metadata_id>', harvest_catalogue, name='harvest-catalogue'),
]

editor/urls.py
"""
Author: Michel Peltriaux
Organization: Spatial data infrastructure Rhineland-Palatinate, Germany
Contact: michel.peltriaux@vermkv.rlp.de
Created on: 09.07.19

"""
from django.urls import path
from editor.autocompletes import KeywordAutocomplete, CategoryAutocomplete, DatasetMetadataAutocomplete, \
    ReferenceSystemAutocomplete, ServiceMetadataAutocomplete
from editor.views import *

app_name = 'editor'
urlpatterns = [
    # ToDo: move the autocomplete paths behind view to secure them
    path('keyword-autocomplete/', KeywordAutocomplete.as_view(create_field="keyword"), name="keyword-autocomplete"),
    path('category-autocomplete/', CategoryAutocomplete.as_view(), name="category-autocomplete"),
    path('metadata-autocomplete/', DatasetMetadataAutocomplete.as_view(), name="metadata-autocomplete"),
    path('service-autocomplete/', ServiceMetadataAutocomplete.as_view(), name="service-autocomplete"),
    path('reference-system-autocomplete/', ReferenceSystemAutocomplete.as_view(), name="reference-system-autocomplete"),

    path('metadata/<metadata_id>', edit, name='edit'),

    path('dataset/wizard', add_new_dataset_wizard, name="dataset-metadata-wizard-new"),
    path('dataset/wizard/<metadata_id>', edit_dataset_wizard, name="dataset-metadata-wizard-instance"),

    path('dataset/remove/<metadata_id>', remove_dataset, name='remove-dataset-metadata'),
    path('access/<object_id>', edit_access, name='edit_access'),
    path('access/<metadata_id>/<group_id>/geometry-form/', access_geometry_form, name='access_geometry_form'),
    path('restore/<metadata_id>', restore, name='restore'),
    path('restore-dataset-metadata/<metadata_id>', restore_dataset_metadata, name='restore-dataset-metadata'),
]

service/urls.py
from django.urls import path

from service.views import *

app_name = 'resource'
urlpatterns = [
    path('', index, name='index'),

    path('metadata/<metadata_id>', get_service_metadata, name='get-service-metadata'),
    path('metadata/<metadata_id>/subscribe', metadata_subscription_new, name='subscription-new'),
    path('metadata/dataset/<metadata_id>', get_dataset_metadata, name='get-dataset-metadata'),
    path('metadata/html/<metadata_id>', get_metadata_html, name='get-metadata-html'),

    path('metadata/<metadata_id>/operation', get_operation_result, name='metadata-proxy-operation'),
    path('metadata/<metadata_id>/legend/<int:style_id>', get_metadata_legend, name='metadata-proxy-legend'),

    path('preview/<metadata_id>', get_service_preview, name='get-service-metadata-preview'),

    path('new-update/<metadata_id>', new_pending_update_service, name='new-pending-update'),
    path('pending-update/<metadata_id>', pending_update_service, name='pending-update'),
    path('dismiss-pending-update/<metadata_id>', dismiss_pending_update_service, name='dismiss-pending-update'),
    path('run-update/<metadata_id>', run_update_service, name='run-update'),

    path('remove/<metadata_id>', remove, name='remove'),
    path('activate/<metadata_id>', activate, name='activate'),
    path('add/', add, name='add'),

    path('pending-tasks/', pending_tasks, name="pending-tasks"),
    path('wms-table/', wms_table, name="wms-table"),
    path('wfs-table/', wfs_table, name="wfs-table"),
    path('wms-table/', wms_table, name="wms-table"),
    path('csw-table/', csw_table, name="csw-table"),
    path('dataset-table/', datasets_table, name="dataset-table"),

    path('wms/', wms_index, name='wms-index'),
    path('wfs/', wfs_index, name='wfs-index'),
    path('csw/', csw_index, name='csw-index'),
    path('datasets/', datasets_index, name='datasets-index'),

    path('detail/<object_id>', detail, name='detail'),

    path('logs/', logs_view, name='logs-view'),
    path('logs/download/', logs_download, name='logs-download'),
]

users/urls.py
"""
Author: Michel Peltriaux
Organization: Spatial data infrastructure Rhineland-Palatinate, Germany
Contact: michel.peltriaux@vermkv.rlp.de
Created on: 28.05.19

"""

from django.urls import path

from .views import *
urlpatterns = [
    path('', login_view, name="login"),
    path('home', home_view, name="home"),
    path('account', account, name="account"),
    path('users/password/edit/', password_change, name="password-change"),
    path('users/edit/', account_edit, name="account-edit"),
    path('logout/', logout_view, name='logout'),
    path('password-reset/', password_reset, name='password-reset'),
    path('register/', register, name='register'),
    path('activate/<activation_hash>', activate_user, name='activate-user'),

    path('subscription', subscription_index_view, name='subscription-index'),
    path('subscription/new', subscription_new_view, name='subscription-new'),
    path('subscription/<subscription_id>/edit', subscription_edit_view, name='subscription-edit'),
    path('subscription/<subscription_id>/remove', subscription_remove, name='subscription-remove'),
]

editor/models.py
from django.db import models

# Create your models here.

editor/views.py
from django.urls import reverse
from django.utils.html import format_html
from django.utils.translation import gettext_lazy as _
from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.db.models import Case, When
from django.http import HttpRequest, HttpResponseRedirect
from django.shortcuts import render, get_object_or_404
from django.db.models import Q
from MrMap.decorator import check_permission, check_ownership
from MrMap.messages import SECURITY_PROXY_WARNING_ONLY_FOR_ROOT
from MrMap.responses import DefaultContext
from editor.filters import EditorAccessFilter
from editor.forms import MetadataEditorForm, RemoveDatasetForm, RestoreMetadataForm, RestoreDatasetMetadata, \
    RestrictAccessForm, RestrictAccessSpatially
from editor.tables import EditorAcessTable
from editor.wizards import DATASET_WIZARD_FORMS, DatasetWizard
from service.helper.enums import MetadataEnum, ResourceOriginEnum
from service.models import Metadata
from structure.models import MrMapGroup
from structure.permissionEnums import PermissionEnum
from users.helper import user_helper


@login_required
@check_permission(PermissionEnum.CAN_REMOVE_DATASET_METADATA)
@check_ownership(Metadata, 'metadata_id')
def remove_dataset(request: HttpRequest, metadata_id):
    """ The remove view for dataset metadata

    Args:
        request: The incoming request
        metadata_id: The metadata id
    Returns:
        A rendered view
    """
    metadata = get_object_or_404(Metadata, id=metadata_id)
    if metadata.metadata_type != MetadataEnum.DATASET.value:
        messages.success(request, message=_("You can't delete metadata record"))
        return HttpResponseRedirect(reverse(request.GET.get('current-view', 'home'), ), status=303)

    relations = metadata.get_related_metadatas()
    is_mr_map_origin = True
    for relation in relations:
        if relation.origin != ResourceOriginEnum.EDITOR.value:
            is_mr_map_origin = False
            break
    if is_mr_map_origin is not True:
        messages.success(request, message=_("You can't delete autogenerated datasets"))
        return HttpResponseRedirect(reverse(request.GET.get('current-view', 'home'), ), status=303)

    form = RemoveDatasetForm(data=request.POST or None,
                             request=request,
                             reverse_lookup='editor:remove-dataset-metadata',
                             reverse_args=[metadata_id, ],
                             # ToDo: after refactoring of all forms is done, show_modal can be removed
                             show_modal=True,
                             is_confirmed_label=_("Do you really want to delete this dataset?"),
                             instance=metadata)
    return form.process_request(valid_func=form.process_remove_dataset)


@login_required
@check_permission(
    PermissionEnum.CAN_ADD_DATASET_METADATA
)
def add_new_dataset_wizard(request: HttpRequest, ):
    return DatasetWizard.as_view(form_list=DATASET_WIZARD_FORMS,
                                 ignore_uncomitted_forms=True,
                                 current_view=request.GET.get('current-view'),
                                 title=_(format_html('<b>Add New Dataset</b>')),
                                 id_wizard='add_new_dataset_wizard',
                                 )(request=request)


@login_required
@check_permission(PermissionEnum.CAN_EDIT_METADATA)
@check_ownership(Metadata, 'metadata_id')
def edit_dataset_wizard(request, metadata_id):
    metadata = get_object_or_404(Metadata,
                                 ~Q(metadata_type=MetadataEnum.CATALOGUE.value),
                                 id=metadata_id)
    return DatasetWizard.as_view(form_list=DATASET_WIZARD_FORMS,
                                 ignore_uncomitted_forms=True,
                                 current_view=request.GET.get('current-view'),
                                 current_view_arg=request.GET.get('current-view-arg', None),
                                 instance_id=metadata_id,
                                 title=_(format_html(f'<b>Edit</b> <i>{metadata.title}</i> <b>Dataset</b>')),
                                 id_wizard=f'edit_{metadata.id}_dataset_wizard',
                                 )(request=request)


@login_required
@check_permission(
    PermissionEnum.CAN_EDIT_METADATA
)
@check_ownership(Metadata, 'metadata_id')
def edit(request: HttpRequest, metadata_id):
    """ The edit view for metadata

    Provides editing functions for all elements which are described by Metadata objects

    Args:
        request: The incoming request
        metadata_id: The metadata id
    Returns:
        A rendered view
    """
    metadata = get_object_or_404(Metadata,
                                 ~Q(metadata_type=MetadataEnum.CATALOGUE.value),
                                 id=metadata_id,)
    if metadata.metadata_type == MetadataEnum.DATASET.value:
        return HttpResponseRedirect(reverse("editor:edit-dataset-metadata", args=(metadata_id,)), status=303)

    form = MetadataEditorForm(data=request.POST or None,
                              instance=metadata,
                              request=request,
                              reverse_lookup='editor:edit',
                              reverse_args=[metadata_id, ],
                              # ToDo: after refactoring of all forms is done, show_modal can be removed
                              show_modal=True,
                              has_autocomplete_fields=True,
                              form_title=_("Edit metadata <strong>{}</strong>").format(metadata.title)
                              )
    return form.process_request(valid_func=form.process_edit_metadata)


@login_required
@check_permission(
    PermissionEnum.CAN_EDIT_METADATA
)
@check_ownership(Metadata, 'object_id')
def edit_access(request: HttpRequest, object_id, update_params: dict = None, status_code: int = 200,):
    """ The edit view for the operations access

    Provides a form to set the access permissions for a metadata-related object.
    Processes the form input afterwards

    Args:
        request (HttpRequest): The incoming request
        id (int): The metadata id
    Returns:
         A rendered view
    """
    template = "views/editor_edit_access_index.html"
    user = user_helper.get_user(request)
    md = get_object_or_404(Metadata,
                           ~Q(metadata_type=MetadataEnum.CATALOGUE.value),
                           id=object_id)
    is_root = md.is_root()

    form = RestrictAccessForm(
        data=request.POST or None,
        request=request,
        action_url=reverse('editor:edit_access', args=[object_id, ], ),
        metadata=md
    )

    all_groups = MrMapGroup.objects.filter(
        is_permission_group=False
    )
    all_groups = MrMapGroup.objects.filter(
        is_public_group=True
    ) | all_groups

    all_groups = all_groups.order_by(
        Case(
            When(
                is_public_group=True,
                then=0
            )
        ),
        'name'
    )

    table = EditorAcessTable(
        request=request,
        queryset=all_groups,
        filter_set_class=EditorAccessFilter,
        current_view='editor:edit_access',
        metadata_relations=md,
    )

    params = {
        "restrict_access_form": form,
        "restrict_access_table": table,
        "service_metadata": md,
        "is_root": is_root,
    }

    if request.method == 'POST':
        # Check if update form is valid or action is performed on a root metadata
        if not is_root:
            messages.error(request, SECURITY_PROXY_WARNING_ONLY_FOR_ROOT)
        elif form.is_valid():
            form.process_securing_access(md)

    if update_params:
        params.update(update_params)

    context = DefaultContext(request, params, user)
    return render(request=request,
                  template_name=template,
                  context=context.get_context(),
                  status=status_code)


@login_required
def access_geometry_form(request: HttpRequest, metadata_id, group_id):
    """ Renders the geometry form for the access editing

    Args:
        request (HttpRequest): The incoming request
        metadata_id (int): The id of the metadata object, which will be edited
        group_id:
    Returns:

    """
    get_object_or_404(Metadata,
                      ~Q(metadata_type=MetadataEnum.CATALOGUE.value),
                      id=metadata_id)
    group = get_object_or_404(MrMapGroup, id=group_id)
    form = RestrictAccessSpatially(
        data=request.POST or None,
        request=request,
        reverse_lookup='editor:access_geometry_form',
        reverse_args=[metadata_id, group_id],
        # ToDo: after refactoring of all forms is done, show_modal can be removed
        show_modal=True,
        form_title=_(f"Edit spatial area for group <strong>{group.name}</strong>"),
        metadata_id=metadata_id,
        group_id=group_id,
    )
    return form.process_request(valid_func=form.process_restict_access_spatially)


@login_required
@check_permission(
    PermissionEnum.CAN_EDIT_METADATA
)
@check_ownership(Metadata, 'metadata_id')
def restore(request: HttpRequest, metadata_id):
    """ Drops custom metadata and load original metadata from capabilities and ISO metadata

    Args,
        request: The incoming request
        id: The metadata id
    Returns:
         Redirects back to edit view
    """
    metadata = get_object_or_404(Metadata,
                                 ~Q(metadata_type=MetadataEnum.CATALOGUE.value),
                                 id=metadata_id)

    form = RestoreMetadataForm(data=request.POST or None,
                               request=request,
                               reverse_lookup='editor:restore',
                               reverse_args=[metadata_id, ],

editor/templates/includes/editor_edit_access.html
{% extends 'sceletons/card.html' %}
{% load i18n static %}
{% load bootstrap4 %}
{% load django_tables2 %}


{% block card-header-title-left %}
<h4 class="mb-1 mr-3">{% autoescape off %}{{THEME.ICONS.ACCESS}}{% endautoescape %} {% trans 'Access Editor' %}</h4>
{% endblock %}

{% block card-header-subtitle-left %}
<h5 class="text-muted">
    {% if service_metadata.is_root %}
        {% trans 'Service:' %}
    {% elif service_metadata.is_featuretype_metadata %}
        {% trans 'Featuretype:' %}
    {% elif service_metadata.is_layer_metadata %}
        {% trans 'Layer:' %}
    {% endif %}
    {{ service_metadata.title }}
</h5>

{% endblock %}

{% block card-header-title-right %}
{% endblock %}

{% block card-header-subtitle-right %}
    <a class="{{THEME.CARD.LINK_COLOR}}" href="{% url 'resource:detail' service_metadata.id %}">
    <span style="white-space: nowrap;">{% autoescape off %}{{THEME.ICONS.RETURN}}{% endautoescape %} {% trans 'Service Detail View' %}</span>
    </a>
{% endblock %}


{% block card-body %}

<h5>
    {% trans 'General settings' %}
</h5>
    <form id="id_restrict_access_form" action="{{ restrict_access_form.action_url }}" method="post">
        {% csrf_token %}

        {% bootstrap_form restrict_access_form  %}
    </form>
    <hr>

<h5>
    {% trans 'Edit group access' %}
</h5>
<div id="id_div_restrict_access_table" {% if not restrict_access_form.restrict_access.value %} style="pointer-events: none; opacity: 0.4;" {% endif %}>
    {% render_table restrict_access_table %}
</div>

<script type="application/javascript">
    // disable submit buttons to prevent multi submitting by user
    var buttonClicked = "";
    $("#id_modal_{{id_modal}} form button, input").click(function(e){
        buttonClicked = $(this);
    });

    var use_proxy_checked = $('#id_use_proxy').prop('checked')
    var log_proxy_checked = $('#id_log_proxy').prop('checked')
    var restrict_access_checked = $('#id_restrict_access').prop('checked')

    $(':checkbox').change(function() {
        if ( use_proxy_checked && $('#id_use_proxy').prop('checked') == false ) {
            // disable all checkboxes, cause all depends on proxy usage
            $('#id_log_proxy').prop('checked', false);
            $('#id_restrict_access').prop('checked', false);
        } else if ( $('#id_log_proxy').prop('checked') == true ) {
            $('#id_use_proxy').prop('checked', true);
            $('#id_log_proxy').prop('checked', true);
        } else if ( $('#id_restrict_access').prop('checked') == true ) {
            $('#id_use_proxy').prop('checked', true);
        }

        if ( $('#id_restrict_access').prop('checked') == false ) {
            $('#id_div_restrict_access_table').css('pointer-events', 'none');
            $('#id_div_restrict_access_table').css('opacity', '0.4');
        }

        // show spinner to signal the user that something is going on
        if ( buttonClicked.is( ":button" ) ) {
            buttonClicked.html(`{% include "includes/loading_spinner.html" %}`);
        }

        if ( buttonClicked.is( ":input" ) ) {
            var label = $("label[for='" + buttonClicked.attr('id') + "']");
            label.html(`{% include "includes/loading_spinner.html" %}`);
        }

        buttonClicked="";

        $("#id_restrict_access_form").submit();


    });
</script>

{% endblock %}

editor/templates/includes/editor_metadata.html
{% extends 'sceletons/card.html' %}
{% load i18n static tz %}
{% load django_tables2 %}
{% load fontawesome_5 %}
{% load query_parameters %}
{% load bootstrap4 %}


{% block card-header-title-left %}
    <h4 class="mb-1 mr-3">{% autoescape off %}{{THEME.ICONS.METADATA}}{% endautoescape %} {% trans 'Metadata editor' %}</h4>
{% endblock %}

{% block card-header-title-right %}
{% endblock %}

{% block card-header-subtitle-left %}
    <h5 class="text-muted">
        {% if service_metadata.is_root %}
            Service:
        {% elif service_metadata.is_featuretype_metadata %}
            Featuretype:
        {% elif service_metadata.is_layer_metadata %}
            Layer:
        {% elif service_metadata.metadata_type == 'dataset' %}
            Dataset:
        {% endif %}
        {{ service_metadata.title }}
    </h5>
{% endblock %}
{% block card-header-subtitle-right %}
    {% if service_metadata.metadata_type != 'dataset' %}
        <a class="{{THEME.CARD.LINK_COLOR}}" href="{% url 'resource:detail' service_metadata.id %}">
            <span style="white-space: nowrap;">{% autoescape off %}{{THEME.ICONS.RETURN}}{% endautoescape %} {% trans 'Service detail view' %}</span>
        </a>
    {% endif %}
{% endblock %}


{% block card-body %}

<div class="row">
   <div class="col">
       <a class="btn {{THEME.CARD.BTN_WARNING_COLOR}}" href="{% if service_metadata.metadata_type == 'dataset' %} {% url 'editor:restore-dataset-metadata' service_metadata.id %} {% else %} {% url 'editor:restore' service_metadata.id %} {% endif %}">{% autoescape off %}{{THEME.ICONS.UNDO}}{% endautoescape %} {% trans 'Restore metadata' %}</a>
   </div>
</div>

<div class="row mt-2">
   <div class="col">
       <form action={{form.action_url}} method="post" class="form">
           {% csrf_token %}
           <div class="row">
                <div class="col">
                    {% bootstrap_form form %}
                    {% include 'sceletons/autocomplete_form_media.html' %}
                </div>
            </div>
            <div class="row">
                <div class="col">
                    <button type="submit" class="btn {{THEME.CARD.BTN_PRIMARY_COLOR}}">{% autoescape off %}{{THEME.ICONS.SAVE}}{% endautoescape %} {% trans 'Save'%}</button>
                </div>
            </div>
       </form>
   </div>
</div>

{% endblock %}